context("Test mfpca")

test_that("all mfpca functions work on the DTI example", {
  skip_on_cran()

  data(DTI)
  DTI <- subset(DTI, Nscans < 6)  ## example where all subjects have 6 or fewer visits
  id <- DTI$ID
  Y <- DTI$cca

  mfpca.sc.DTI <- mfpca.sc(Y = Y, id = id, twoway = TRUE)
  mfpca.face.DTI <- mfpca.face(Y = Y, id = id, twoway = TRUE)

  expect_equal(dim(mfpca.face.DTI$Yhat)[1], dim(mfpca.sc.DTI$Yhat)[1])
  expect_equal(dim(mfpca.face.DTI$Yhat.subject)[1], dim(mfpca.sc.DTI$Yhat.subject)[1])
  expect_equal(dim(mfpca.face.DTI$scores$level1)[1], dim(mfpca.sc.DTI$scores$level1)[1])
  expect_equal(dim(mfpca.face.DTI$scores$level2)[1], dim(mfpca.sc.DTI$scores$level2)[1])
})

test_that("mfpca.face options work", {
  skip_on_cran()

  data(DTI)
  DTI <- subset(DTI, Nscans < 6)  ## example where all subjects have 6 or fewer visits
  id <- DTI$ID
  Y <- DTI$cca
  mfpca.base <- mfpca.face(Y = Y, id = id)

  # visit argument
  mfpca.visit <- mfpca.face(Y = Y, id = id, visit = DTI$visit)
  expect_equal(mfpca.base$npc$level1, mfpca.visit$npc$level1)

  # weight argument
  mfpca.weight <- mfpca.face(Y = Y, id = id, weight = "subj")
  expect_equal(dim(mfpca.base$scores$level1)[1], dim(mfpca.weight$scores$level1)[1])

  # pve argument
  mfpca.pve <- mfpca.face(Y = Y, id = id, pve = 0.95)
  expect_equal(dim(mfpca.base$scores$level1)[1], dim(mfpca.pve$scores$level1)[1])

  # npc argument
  mfpca.npc <- mfpca.face(Y = Y, id = id, npc = 5)
  expect_equal(mfpca.npc$npc$level1, 5)
  expect_equal(mfpca.npc$npc$level2, 5)
})

# context("Testing pfr's peer()")
#
# test_that("peer with D2 penalty", {
#   skip_on_cran()
#
#   data(DTI)
#   DTI = DTI[which(DTI$case == 1),]
#   fit.D2 <- pfr(pasat ~ peer(cca, pentype="D"), data=DTI)
#   expect_is(fit.D2, "pfr")
# })

# test_that("peer with structured penalty works", {
#   skip_on_cran()
#
#   data(PEER.Sim, Q)
#
#   # Setting k to max possible value
#   fit.decomp <- pfr(Y ~ peer(W, pentype="Decomp", Q=Q, k=99),
#                     data=subset(PEER.Sim, t==0))
#   expect_is(fit.decomp, "pfr")
# })

context("Testing pcre")

test_that("pcre works as expected", {
  skip_on_cran()

  residualfunction <- function(t){
    #generate quintic polynomial error functions
    drop(poly(t, 5)%*%rnorm(5, sd=sqrt(2:6)))
  }
  # generate data Y(t) = mu(t) + E(t) + white noise
  set.seed(1122)
  n <- 50
  T <- 30
  t <- seq(0,1, l=T)
  # E(t): smooth residual functions
  E <- t(replicate(n, residualfunction(t)))
  int <- matrix(scale(3*dnorm(t, m=.5, sd=.5) - dbeta(t, 5, 2)), byrow=T, n, T)
  Y <- int + E + matrix(.2*rnorm(n*T), n, T)
  data <- data.frame(Y=I(Y))
  # fit model under independence assumption:
  summary(m0 <- pffr(Y ~ 1, yind=t, data=data))
  # get first 5 eigenfunctions of residual covariance
  # (i.e. first 5 functional PCs of empirical residual process)
  Ehat <- resid(m0)
  fpcE <- fpca.sc(Ehat, npc=5)
  ##expect_equal_to_reference(fpcE, "pcre.fpca.obj.rds")
  #expect_is(fpcE, "list")

  efunctions <- fpcE$efunctions
  evalues <- fpcE$evalues
  data$id <- factor(1:nrow(data))
  # refit model with fpc-based residuals
  m1 <- pffr(Y ~ 1 + pcre(id=id, efunctions=efunctions, evalues=evalues, yind=t), yind=t, data=data)
  ## expect_equal_to_reference(m1, "pcre.pffr.obj.rds")
  expect_is(m1, "pffr")
  re <- predict(m1, type = "terms")[[2]]
  expect_equivalent(colSums(re), rep(0, T))

  expect_is(summary(m1), "summary.pffr")
})

test_that("pcre works for sparse", {
  skip_on_cran()

  residualfunction <- function(t){
    #generate quintic polynomial error functions
    drop(poly(t, 5)%*%rnorm(5, sd=sqrt(2:6)))
  }
  # generate data Y(t) = mu(t) + E(t) + white noise
  set.seed(1122)
  n <- 50
  T <- 30
  t <- seq(0,1, l=T)
  # E(t): smooth residual functions
  E <- t(replicate(n, residualfunction(t)))
  int <- matrix(scale(3*dnorm(t, m=.5, sd=.5) - dbeta(t, 5, 2)), byrow=T, n, T)
  Y <- int + E + matrix(.2*rnorm(n*T), n, T)
  data <- data.frame(Y=I(Y))
  # fit model under independence assumption:
  summary(m0 <- pffr(Y ~ 1, yind=t, data=data))
  # get first 5 eigenfunctions of residual covariance
  # (i.e. first 5 functional PCs of empirical residual process)
  Ehat <- resid(m0)
  fpcE <- fpca.sc(Ehat, npc=5)
  ##expect_equal_to_reference(fpcE, "pcre.fpca.obj.rds")
  #expect_is(fpcE, "list")

  efunctions <- fpcE$efunctions
  evalues <- fpcE$evalues

  # make sparse data:
  propmissing <- .5
  nygrid <- T
  missing <- sample(c(rep(T, propmissing*n*nygrid),
                      rep(F, n*nygrid-propmissing*n*nygrid)))

  ydata <- data.frame(.obs = rep(1:n, each=nygrid)[!missing],
                      .index = rep(t, times=n)[!missing],
                      .value = as.vector(t(data$Y))[!missing])

  data <- data.frame(id = factor(1:nrow(data)))

  # refit model with fpc-based residuals
  m1 <- pffr(Y ~ 1 + pcre(id=id, efunctions=efunctions, evalues=evalues, yind=t), yind=t,
             data=data, ydata = ydata)
  ## expect_equal_to_reference(m1, "pcre.pffr.obj.rds")
  expect_is(m1, "pffr")

  t1 <- predict(m1, type="terms")
  ## expect_equal_to_reference(t1, "pcre.prediction.obj.rds")
  expect_is(t1, "list")

  re <- predict(m1, type = "terms", newdata = data)[[2]]
  expect_equivalent(colSums(re), rep(0, T))

  expect_is(summary(m1), "summary.pffr")
})

context("Testing functional PCR")


test_that("Check that all 3 fpcr calls yield essentially identical estimates", {
  skip_on_cran()

  data(gasoline)

  # Create the requisite functional data objects
  bbasis = create.bspline.basis(c(900, 1700), 40)
  wavelengths = 2*450:850
  nir <- t(gasoline$NIR)
  gas.fd = smooth.basisPar(wavelengths, nir, bbasis)$fd

  # Method 1: Call fpcr with fdobj argument
  gasmod1 = fpcr(gasoline$octane, fdobj = gas.fd, ncomp = 30)
  #plot(gasmod1, xlab="Wavelength")

  # Method 2: Call fpcr with explicit signal matrix
  gasmod2 = fpcr(gasoline$octane, xfuncs = gasoline$NIR, ncomp = 30)
  # Method 3: Call fpcr with explicit signal, basis, and penalty matrices
  gasmod3 = fpcr(gasoline$octane, xfuncs = gasoline$NIR,
                 basismat = eval.basis(wavelengths, bbasis),
                 penmat = getbasispenalty(bbasis), ncomp = 30)

  # Check that all 3 calls yield essentially identical estimates
  #expect_equal(gasmod1$fhat, gasmod2$fhat, gasmod3$fhat)
  tmp <- abs(c(gasmod1$fhat-gasmod2$fhat, gasmod1$fhat-gasmod2$fhat))
  expect_lt(max(tmp), 1e-10)
  # But note that, in general, you'd have to specify argvals in Method 1
  # to get the same coefficient function values as with Methods 2 & 3.
})

test_that("Cross-validation is working", {
  skip_on_cran()
  set.seed(8659)
  data(gasoline)
  cv.gas = fpcr(gasoline$octane, xfuncs = gasoline$NIR,
                nbasis=seq(20,40,5), ncomp = seq(10,20,5), store.cv = TRUE)
  expect_is(cv.gas, "fpcr")

  ## expect_equal_to_reference(cv.gas$cv.table, "fpcr.cv.rds")
})

context("Testing pffr")

set.seed(9312)
data2 <- pffrSim(scenario = "all", n = 30)
argvals <- attr(data2, "yindex")
s <- attr(data2, "xindex")
m2 <- pffr(Y ~
    #linear function-on-function
    ff(X1, xind = s) +
    #varying coefficient term
    xlin  +
    #bivariate smooth term in xte1 & xte2, const. over Y-index
    c(te(xte1, xte2)) +
    #smooth effect of xsmoo varying over Y-index
    s(xsmoo) +
    # linear effect of xconst constant over Y-index
    c(xconst),
  yind = argvals,
  data = data2)

test_that("all major pffr terms are working", {
  ## expect_equal_to_reference(m.pc$coefficients, "pffr.all.coef.rds")
  expect_is(m2, "pffr")
})

test_that("convenience functions are working", {
  expect_is(summary(m2), "summary.pffr")
  ## plot(m2, pers = TRUE)
  expect_is(coef(m2), "list")
  # convenience functions:
  preddata <- pffrSim(scenario = "all", n = 20)
  expect_is(predict(m2, newdata = preddata), "matrix")

  expect_equal(length(predict(m2, type = "terms")), 6L)
  cm2 <- coef(m2)
  expect_is(cm2$pterms, "matrix")
  # str(cm2$smterms, 2)
  # str(cm2$smterms[["s(xsmoo)"]]$coef)
})
#############################################################################
# sparse data (80% missing on a regular grid):
test_that("pffr with sparse data works", {
  set.seed(88182004)
  data3 <- pffrSim(scenario = c("int", "smoo"), n = 30, propmissing = 0.8)
  t <- attr(data3, "yindex")
  m3.sparse <- pffr(Y ~ s(xsmoo), data = data3$data, ydata = data3$ydata, yind = t)
  expect_is(summary(m3.sparse), "summary.pffr")
  ## plot(m3.sparse, pers = TRUE, pages = 1)
})

set.seed(1122)
n <- 55
S <- 60
n.argvals <- 50
s <- seq(0,1, l = S)
argvals <- seq(0,1, l = n.argvals)

#generate X from a polynomial FPC-basis:
rankX <- 5
Phi <- cbind(1/sqrt(S), poly(s, degree = rankX-1))
lambda <- rankX:1
Xi <- sapply(lambda, function(l)
  scale(rnorm(n, sd = sqrt(l)), scale = FALSE))
X <- Xi %*% t(Phi)

beta.st <- outer(s, argvals, function(s, argvals) cos(2 * pi * s * argvals))

y <- (1/S*X) %*% beta.st + 0.1 * matrix(rnorm(n * n.argvals), nrow = n, ncol = n.argvals)

data <- list(y = y, X = X)

test_that("ffpc terms are working", {
  skip_on_cran()


  # set number of FPCs to true rank of process for this example:
  m.pc <- pffr(y ~ c(1) + 0 + ffpc(X, yind = argvals, decomppars = list(npc = rankX)),
    data = data, yind = argvals)
  ## expect_equal_to_reference(m.pc$coefficients, "pffr.ffpc.coef.rds")
  expect_is(m.pc, "pffr")
  expect_is(summary(m.pc), "summary.pffr")

  #expect_is(ffpcplot(m.pc, type = "surf", auto.layout = FALSE, theta  =  50, phi  =  40), "list")
})

# test_that("another ff term example", {
#   m.ff <- pffr(y ~ c(1) + 0 + ff(X, yind = argvals), data = data, yind = argvals)
#   expect_equal_to_reference(m.ff$coefficients, "pffr.ff.coef.rds")
# 
#   expect_is(summary(m.ff), "summary.pffr")
# 
#   # fits are very similar:
#   # expect_equal(fitted(m.pc), fitted(m.ff))  # NOT TRUE
# })

test_that("ff limits arg works", {
  set.seed(2121)
  data <- pffrSim(scenario = "ff", n = 20, SNR = 100, limits = function(s, t) s < t)
  t <- attr(data, "yindex")
  s <- attr(data, "xindex")
  m.l <- pffr(Y ~ ff(X1, xind = s, limits = "s<t"), yind = t, data = data)
  m.leq <- pffr(Y ~ ff(X1, xind = s, limits = "s<=t"), yind = t, data = data)
  m.fun <- pffr(Y ~ ff(X1, xind = s, limits = function(s, t) s < t), yind = t, data = data)
  expect_equal(fitted(m.l), fitted(m.fun))
  expect_true(
    max(abs((fitted(m.l) - fitted(m.leq))/fitted(m.l))) < .05)
})

test_that("weights and offset args work", {
  skip_on_cran()
  set.seed(112)
  n <- 20
  nygrid <- 50
  data <- pffrSim(scenario = "lin", n = n, nygrid = nygrid, SNR = 100)
  t <- attr(data, "yindex")
  m0 <- pffr(Y ~ xlin, yind = t, data = data)

  vecoffset <- 1:n
  data$Y_vecoffset <- data$Y + vecoffset
  m_vecoffset <- pffr(Y_vecoffset ~ xlin, yind = t, data = data, offset = vecoffset)
  expect_equal(fitted(m0), fitted(m_vecoffset)-vecoffset, tolerance  =  1e-5)

  matoffset <- matrix(rnorm(n*nygrid), n, nygrid)
  data$Y_matoffset <- data$Y + matoffset
  m_matoffset <- pffr(Y_matoffset ~ xlin, yind = t, data = data, offset = matoffset)
  expect_equal(fitted(m0), fitted(m_matoffset) - matoffset, tolerance  =  1e-5)

  expect_error(pffr(Y ~ xlin, yind = t, data = data, offset = vecoffset[-1]))
  expect_error(pffr(Y ~ xlin, yind = t, data = data, offset = matoffset[-1, ]))
})

test_that("sff terms are working", {
  skip_on_cran()

  set.seed(2121)
  data <- pffrSim(scenario = "ff", n = 20, SNR = 100)
  t <- attr(data, "yindex")
  s <- attr(data, "xindex")
  m.s <- pffr(Y ~ sff(X1, xind = s), yind = t, data = data)
  m.lin <- pffr(Y ~ ff(X1, xind = s), yind = t, data = data)
  expect_is(summary(m.s), "summary.pffr")
  expect_true(
    max(abs((fitted(m.lin) - fitted(m.s))/fitted(m.lin))) < .05 )
  expect_equal(fitted(m.s), predict(m.s, newdata  =  data))
})


test_that("ff identifiability stuff works", {
  skip_on_cran()

  set.seed(112)
  n <- 20
  ngrid <- 50
  s <- t <- seq(0, 1, l = ngrid)
  Xefcts <- t(poly(t, 2))
  X <- matrix(rnorm(n*2), n, 2) %*% Xefcts
  L <- matrix(1/ngrid, ncol = ngrid, nrow = n)
  LX <- L*X
  beta.st <- outer(s, t, function(s, t) cos(3*pi*t)*s)
  Y <- LX%*%beta.st
  data <- data.frame(Y = I(Y), X = I(X))

  expect_warning(m <- pffr(Y ~ ff(X, xind = s), yind = t, data = data), "kernel overlap")
})

context("Testing old lpfr")

test_that("lpfr works with one predictor", {
  skip_on_cran()

  data(DTI)

  # subset data as needed for this example
  cca = DTI$cca[which(DTI$case == 1),]
  rcst = DTI$rcst[which(DTI$case == 1),]
  DTI = DTI[which(DTI$case == 1),]


  # note there is missingness in the functional predictors
  # apply(is.na(cca), 2, mean)
  # apply(is.na(rcst), 2, mean)


  # fit two models with single functional predictors and plot the results
  #fit.cca = lpfr(Y=DTI$pasat, subj=DTI$ID, funcs = cca, smooth.cov=FALSE)
  fit.rcst = lpfr(Y=DTI$pasat, subj=DTI$ID, funcs = rcst, smooth.cov=FALSE)
  ## expect_equal_to_reference(fit.cca$BetaHat, "lpfr.cca.coef.rds")
  expect_is(fit.rcst, "list")
  expect_equal(length(fit.rcst), 10)
})

test_that("lpfr works two predictors", {
  skip_on_cran()

  data(DTI)

  # subset data as needed for this example
  cca = DTI$cca[which(DTI$case == 1),]
  rcst = DTI$rcst[which(DTI$case == 1),]
  DTI = DTI[which(DTI$case == 1),]

  # fit a model with two functional predictors and plot the results
  fit.cca.rcst = lpfr(Y=DTI$pasat, subj=DTI$ID, funcs = list(cca,rcst),
                      smooth.cov=FALSE)
  expect_is(fit.cca.rcst, "list")
  ## expect_equal_to_reference(fit.cca.rcst, "lpfr.fit.rds")
})

context("Testing fpca.xxx")

set.seed(12212)
n <- 100
ngrid <- 40
t <- seq(0, 1, l=ngrid)
efcts <- poly(t, 2)
Y <- outer(2 * drop(scale(rnorm(n))), efcts[, 1]) +
  outer(drop(scale(rnorm(n))), efcts[, 2])

flip_efunctions <- function(ef1, ef2) {
  squared_diff <- function(x,y) crossprod(x - y)
  for(i in 1:ncol(ef1)){
    if(squared_diff(ef1[,i], ef2[,i]) > squared_diff(ef1[,i], - ef2[,i])){
      ef2[,i] <- -ef2[,i]
    }
  }
  ef2
}

test_that("all fpca functions agree on toy example", {
  skip_on_cran()

  sc <- fpca.sc(Y)
  face <- fpca.face(Y)
  #ssvd <- fpca.ssvd(Y)
  #twos <- fpca2s(Y)

  expect_equal(sc$Yhat, unname(face$Yhat), tolerance=.01)
  #expect_equal(sc$Yhat, ssvd$Yhat, tolerance=.01)
  #expect_equal(sc$Yhat, twos$Yhat, tolerance=.01)

  #ssvd$efunctions <- flip_efunctions(sc$efunctions, ssvd$efunctions)
  #expect_equal(sc$efunctions, ssvd$efunctions, tolerance=.1)
  #expect_equal(sc$evalues, ssvd$evalues, tolerance=.1)

  #twos$efunctions <- flip_efunctions(sc$efunctions, twos$efunctions)
  #expect_equal(sc$efunctions, twos$efunctions, tolerance=.1)
  #expect_equal(sc$evalues, twos$evalues, tolerance=.1)

  if(FALSE){
    ##TODO: - fix quadrature weights first
    ##      - flip sign of efunctions if necessary
    expect_equal(sc$efunctions, face$efunctions, tolerance=.01)
    #expect_equal(sc$efunctions, twos$efunctions, tolerance=.01)
    expect_equal(sc$evalues, face$evalues, tolerance=.01)
    #expect_equal(sc$evalues, ssvd$evalues, tolerance=.01)
    #expect_equal(sc$evalues, twos$evalues, tolerance=.01)
  }
})

test_that("fpca.sc options work", {
  skip_on_cran()

  sc <- fpca.sc(Y)
  sc_cov1 <- fpca.sc(Y, cov.est.method = 1)
  #sc_sym <- fpca.sc(Y, useSymm = TRUE)
  #sc_int <- fpca.sc(Y, random.int = TRUE)

  expect_equal(sc$Yhat, sc_cov1$Yhat, tolerance=.02)
  #expect_equal(sc$Yhat, sc_sym$Yhat, tolerance=.01)
  #expect_equal(sc$Yhat, sc_int$Yhat, tolerance=.01)
})


# test_that("fpca.ssvd options work", {
#   skip_on_cran()
#
#   expect_error(fpca.ssvd(Y = 1:10, ydata=data.frame()), "irregular data")
#   expect_warning(fpca.ssvd(Y = Y, argvals=sqrt(t)), "non-equidistant")
#   ssvd <- fpca.ssvd(Y)
#   ssvd_npc1 <- fpca.ssvd(Y, npc=1)
#   ssvd_d2 <- fpca.ssvd(Y, diffpen = 2)
#   expect_equal(ssvd_npc1$efunctions[,1], ssvd$efunctions[,1])
#   expect_true(ncol(ssvd_npc1$efunctions) == 1)
#   expect_equal(ssvd_d2$efunctions, ssvd$efunctions, tol=.01)
# })
#
# test_that("fpca2s options work", {
#   skip_on_cran()
#
#   expect_error(fpca2s(Y = 1:10, ydata=data.frame()), "irregular data")
#   expect_warning(fpca2s(Y = Y, argvals=sqrt(t)), "non-equidistant")
#   twos <- fpca2s(Y)
#   twos_npc1 <- fpca2s(Y, npc=1)
#   expect_equal(twos_npc1$efunctions[,1], twos$efunctions[,1])
#   expect_true(ncol(twos_npc1$efunctions) == 1)
# })

context("Test fosr")

# test_that("fosr Penalized GLS works", {
#   skip_on_cran()
#   require(fda)
#   data("CanadianWeather")
#   ## The first two lines, adapted from help(fRegress) in package fda,
#   ## set up a functional data object representing daily average
#   ## temperatures at 35 sites in Canada
#   daybasis25 <- create.fourier.basis(rangeval=c(0, 365), nbasis=25,
#                                      axes=list('axesIntervals'))
#   Temp.fd <- with(CanadianWeather, smooth.basisPar(day.5,
#                                                    dailyAv[,,'Temperature.C'], daybasis25)$fd)
# 
#   modmat = cbind(1, model.matrix(~ factor(CanadianWeather$region) - 1))
#   constraints = matrix(c(0,1,1,1,1), 1)
# 
#   ## Penalized GLS
#   glsmod = fosr(fdobj = Temp.fd, X = modmat, con = constraints, method="GLS")
#   expect_that(glsmod, is_a("fosr"))
#   plot(glsmod, 1)
# })

# test_that("fosr.perm is working", {
#   skip_on_cran()
# 
#   smallbasis  <- create.fourier.basis(c(0, 365), 25)
#   tempfd <- smooth.basis(day.5,
#                          CanadianWeather$dailyAv[,,"Temperature.C"], smallbasis)$fd
# 
#   Xreg = cbind(1, model.matrix(~factor(CanadianWeather$region)-1))
#   conreg = matrix(c(0,1,1,1,1), 1)   # constrain region effects to sum to 0
# 
#   # This is for illustration only; for a real test, must increase nperm
#   # (and probably prelim as well)
#   regionperm = fosr.perm(fdobj=tempfd, X=Xreg, con=conreg, method="OLS", nperm=10, prelim=3)
#   expect_is(regionperm, "fosr.perm")
#   # Redo the plot, using axisIntervals() from the fda package
#   #plot(regionperm, axes=FALSE, xlab="")
# 
# })
